Index: branches/UKMO/dev_r5518_GO6_package_asm_3d_bgc/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_asm_3d_bgc/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 9291)
+++ branches/UKMO/dev_r5518_GO6_package_asm_3d_bgc/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 9292)
@@ -102,5 +102,11 @@
       !! JPALM (27-06-2016): add lk_oasis for CO2 and DMS coupling with atm
       USE sbc_oce,                    ONLY: lk_oasis
+# if defined key_foam_medusa
+      USE sms_medusa,                 ONLY: hist_pco2, xobs_xco2a,          &
+                                            pgrow_avg, ploss_avg,           &
+                                            phyt_avg, mld_max
+# else
       USE sms_medusa,                 ONLY: hist_pco2
+# endif
       USE trc,                        ONLY: ln_rsttr, nittrc000, trn
       USE bio_medusa_init_mod,        ONLY: bio_medusa_init
@@ -319,4 +325,12 @@
          f_xco2a(:,:) = fq4
       endif
+#  if defined key_foam_medusa
+      IF ( xobs_xco2a > 0.0 ) THEN
+         IF(lwp) WRITE(numout,*) ' using observed atm pCO2 = ', xobs_xco2a
+         f_xco2a(:,:) = xobs_xco2a
+      ELSE
+         IF(lwp) WRITE(numout,*) ' xobs_xco2a <= 0 so using default atm pCO2'
+      ENDIF
+#  endif
 #  if defined key_axy_pi_co2
       !! OCMIP pre-industrial pCO2
@@ -358,7 +372,13 @@
       !!          x * 30d + 1*rdt(i.e: mod = rdt)   
       !!          ++ need to pass carb-chem output var through restarts
+#if defined key_foam_medusa
+      !! DAF (Aug 2017): For FOAM we want to run daily
+      If ( (kt == nittrc000 .AND. .NOT.ln_rsttr) .OR.                        &
+           (mod(kt*rdt,86400.) == rdt) ) THEN
+#else
       If ( (kt == nittrc000 .AND. .NOT.ln_rsttr) .OR.                        &
            ((86400*mod(nn_date0,100) + mod(kt*rdt,2592000.)) == rdt) ) THEN
-         !!---------------------------------------------------------------
+#endif
+         !!----------------------------------------------------------------------
          !! Calculate the carbonate chemistry for the whole ocean on the first
          !! simulation timestep and every month subsequently; the resulting 3D
Index: branches/UKMO/dev_r5518_GO6_package_asm_3d_bgc/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_asm_3d_bgc/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90	(revision 9291)
+++ branches/UKMO/dev_r5518_GO6_package_asm_3d_bgc/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90	(revision 9292)
@@ -90,4 +90,7 @@
 #if defined key_roam
       NAMELIST/natroam/ xthetaphy,xthetazoo,xthetanit,        &
+# if defined key_foam_medusa
+      &    xobs_xco2a,                                        &
+# endif
       &    xthetarem,xo2min 
 #endif
@@ -490,4 +493,11 @@
          &   ' key_debug_medusa                                                       = INACTIVE'
 # endif
+#if defined key_foam_medusa
+         WRITE(numout,*)     &
+         &   ' key_foam_medusa                                                        = ACTIVE'
+#else
+         WRITE(numout,*)     &
+         &   ' key_foam_medusa                                                        = INACTIVE'
+#endif
          WRITE(numout,*) ' '
 
@@ -1030,4 +1040,7 @@
       xthetarem = 0.
       xo2min    = 0.
+# if defined key_foam_medusa
+      xobs_xco2a = 0.
+# endif
 
       !READ(numnatm,natroam)
@@ -1049,4 +1062,7 @@
 !!       xthetarem :  oxygen consumption by carbon remineralisation
 !!       xo2min    :  oxygen minimum concentration
+# if defined key_foam_medusa
+!!       xobs_xco2a : observed atmospheric xCO2
+# endif
 
       IF(lwp) THEN
@@ -1066,4 +1082,8 @@
           WRITE(numout,*)     &
           &   ' oxygen minimum concentration                               xo2min      = ', xo2min
+# if defined key_foam_medusa
+          WRITE(numout,*)     &
+          &   ' observed atmospheric xCO2                                  xobs_xco2a  = ', xobs_xco2a
+# endif
        ENDIF
 
Index: branches/UKMO/dev_r5518_GO6_package_asm_3d_bgc/NEMOGCM/NEMO/TOP_SRC/trcrst.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_asm_3d_bgc/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 9291)
+++ branches/UKMO/dev_r5518_GO6_package_asm_3d_bgc/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 9292)
@@ -45,4 +45,7 @@
    USE oce,     ONLY: CO2Flux_out_cpl, DMS_out_cpl, chloro_out_cpl  !! Coupling variable
    USE trcstat
+#if defined key_foam_medusa
+   USE obs_const, ONLY: obfillflt  ! Observation operator fill value
+#endif
 
    IMPLICIT NONE
@@ -338,6 +341,34 @@
          IF(lwp) WRITE(numout,*) 'Or don t start from uncomplete restart...' 
       ENDIF
+      !
+#  if defined key_foam_medusa
+      !! 2D fields of pCO2 and fCO2 for observation operator on first timestep
+      IF( iom_varid( numrtr, 'PCO2W', ldstop = .FALSE. ) > 0 ) THEN
+         IF(lwp) WRITE(numout,*) ' MEDUSA pCO2 present - reading in ...'
+         CALL iom_get( numrtr, jpdom_autoglo, 'PCO2W',  f2_pco2w(:,:)  )
+         CALL iom_get( numrtr, jpdom_autoglo, 'FCO2W',  f2_fco2w(:,:)  )
+      ELSE
+         IF(lwp) WRITE(numout,*) ' MEDUSA pCO2 absent - setting to fill ...'
+         f2_pco2w(:,:) = obfillflt * tmask(:,:,1)
+         f2_fco2w(:,:) = obfillflt * tmask(:,:,1)
+      ENDIF
+#  endif
 # endif
-
+# if defined key_foam_medusa
+      !! Fields for ocean colour assimilation on first timestep
+      IF( iom_varid( numrtr, 'pgrow_avg', ldstop = .FALSE. ) > 0 ) THEN
+         IF(lwp) WRITE(numout,*) ' MEDUSA pgrow_avg present - reading in ...'
+         CALL iom_get( numrtr, jpdom_autoglo, 'pgrow_avg',  pgrow_avg(:,:)  )
+         CALL iom_get( numrtr, jpdom_autoglo, 'ploss_avg',  ploss_avg(:,:)  )
+         CALL iom_get( numrtr, jpdom_autoglo, 'phyt_avg',   phyt_avg(:,:)   )
+         CALL iom_get( numrtr, jpdom_autoglo, 'mld_max',    mld_max(:,:)    )
+      ELSE
+         IF(lwp) WRITE(numout,*) ' MEDUSA pgrow_avg absent - setting to zero ...'
+         pgrow_avg(:,:) = 0.0
+         ploss_avg(:,:) = 0.0
+         phyt_avg(:,:)  = 0.0
+         mld_max(:,:)   = 0.0
+      ENDIF
+# endif
 
 #endif
@@ -510,4 +541,18 @@
       call trc_rst_dia_stat( f2_ccd_arg(:,:),'CCD_ARG')
       !!
+#  if defined key_foam_medusa
+      !! Fields for observation operator on first timestep
+      IF(lwp) WRITE(numout,*) ' MEDUSA OBS fields - writing out ...'
+      CALL iom_rstput( kt, nitrst, numrtw, 'PCO2W', f2_pco2w(:,:)  )
+      CALL iom_rstput( kt, nitrst, numrtw, 'FCO2W', f2_fco2w(:,:)  )
+#  endif
+# endif
+# if defined key_foam_medusa
+      !! Fields for assimilation on first timestep
+      IF(lwp) WRITE(numout,*) ' MEDUSA ASM fields - writing out ...'
+      CALL iom_rstput( kt, nitrst, numrtw, 'pgrow_avg', pgrow_avg(:,:) )
+      CALL iom_rstput( kt, nitrst, numrtw, 'ploss_avg', ploss_avg(:,:) )
+      CALL iom_rstput( kt, nitrst, numrtw, 'phyt_avg',  phyt_avg(:,:)  )
+      CALL iom_rstput( kt, nitrst, numrtw, 'mld_max',   mld_max(:,:)   )
 # endif
 !!
